diff --git a/src/misc_gui.cpp b/src/misc_gui.cpp
--- a/src/misc_gui.cpp
+++ b/src/misc_gui.cpp
@@ -33,6 +33,8 @@
 
 #include "table/strings.h"
 
+#include <time.h>
+
 /**
  * Try to retrive the current clipboard contents.
  *
@@ -183,6 +185,11 @@
 		GetString(this->landinfo_data[line_nr], td.str, lastof(this->landinfo_data[line_nr]));
 		line_nr++;
 
+		/* Height */
+		SetDParam(0, TileHeight(tile));
+		GetString(this->landinfo_data[line_nr], STR_LAND_AREA_INFORMATION_LANDINFO_HEIGHT, lastof(this->landinfo_data[line_nr]));
+		line_nr++;
+
 		/* Up to four owners */
 		for (uint i = 0; i < 4; i++) {
 			if (td.owner_type[i] == STR_NULL) continue;
@@ -814,17 +821,28 @@
 
 /**
  * Display animated feeder income.
- * @param x    World X position of the animation location.
- * @param y    World Y position of the animation location.
- * @param z    World Z position of the animation location.
- * @param cost Estimated feeder income.
+ * @param x        World X position of the animation location.
+ * @param y        World Y position of the animation location.
+ * @param z        World Z position of the animation location.
+ * @param transfer Estimated feeder income.
+ * @param income   Real income from goods being delivered to their final destination.
  */
-void ShowFeederIncomeAnimation(int x, int y, int z, Money cost)
+void ShowFeederIncomeAnimation(int x, int y, int z, Money transfer, Money income)
 {
 	Point pt = RemapCoords(x, y, z);
 
-	SetDParam(0, cost);
-	AddTextEffect(STR_FEEDER, pt.x, pt.y, DAY_TICKS, TE_RISING);
+	SetDParam(0, transfer);
+	if (income == 0) {
+		AddTextEffect(STR_FEEDER, pt.x, pt.y, DAY_TICKS, TE_RISING);
+	} else {
+		StringID msg = STR_FEEDER_COST;
+		if (income < 0) {
+			income = -income;
+			msg = STR_FEEDER_INCOME;
+		}
+		SetDParam(1, income);
+		AddTextEffect(msg, pt.x, pt.y, DAY_TICKS, TE_RISING);
+	}
 }
 
 /**
@@ -1685,3 +1703,73 @@
 
 	new QueryWindow(&_query_desc, caption, message, parent, callback);
 }
+
+/** Widgets of the system time window. */
+enum SystemTimeWindowWidgets {
+	TW_TIME_TEXT,      ///< The time text (eg. 2009-12-31 14:55:55)
+};
+
+static const NWidgetPart _nested_time_widgets[] = {
+	NWidget(NWID_HORIZONTAL),
+		NWidget(WWT_CLOSEBOX, COLOUR_GREY),
+		NWidget(WWT_CAPTION,  COLOUR_GREY),  SetDataTip(STR_SYSTEM_TIME, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
+		NWidget(WWT_SHADEBOX, COLOUR_GREY),
+		NWidget(WWT_STICKYBOX, COLOUR_GREY),
+	EndContainer(),
+	NWidget(WWT_PANEL, COLOUR_CREAM),
+	NWidget(WWT_FRAME, COLOUR_CREAM), SetPadding(0, 5, 1, 5),
+			NWidget(WWT_EMPTY, INVALID_COLOUR, TW_TIME_TEXT),
+	EndContainer(),
+};
+
+static const WindowDesc _time_desc(
+	WDP_AUTO, 0, 0,
+	WC_SYSTEM_TIME, WC_NONE,
+	0,
+	_nested_time_widgets, lengthof(_nested_time_widgets)
+);
+
+struct TimeWindow : public Window {
+	time_t last_time;
+
+	TimeWindow() : Window(), last_time(0)
+	{
+		this->InitNested(&_time_desc);
+		this->flags4 |= WF_STICKY;
+	}
+
+	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
+	{
+		Dimension d = GetStringBoundingBox("2009-09-09 20:00:00");
+
+		*size = maxdim(*size, d);
+	}
+
+	virtual void OnPaint()
+	{
+		this->DrawWidgets();
+	}
+
+	virtual void DrawWidget(const Rect &r, int widget) const
+	{
+		static char buf[1024];
+		time_t now = time(NULL);
+
+		strftime(buf, sizeof(buf), "%Y-%m-%d %H:%M:%S", localtime(&now));
+
+		DrawString(r.left + 2, r.right - 2, r.top + 4, buf, TC_WHITE, SA_LEFT | SA_FORCE);
+	}
+
+	virtual void OnTick()
+	{
+		time_t now = time(NULL);
+		if (now != this->last_time)
+			this->SetDirty();
+	}
+};
+
+void ShowSystemTimeWindow()
+{
+	DeleteWindowById(WC_SYSTEM_TIME, 0);
+	new TimeWindow();
+}
diff --git a/src/moving_average.cpp b/src/moving_average.cpp
new file mode 100644
--- /dev/null
+++ b/src/moving_average.cpp
@@ -0,0 +1,31 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file moving_average.cpp Implementation of moving average functions */
+
+#include "moving_average.h"
+#include "date_func.h"
+#include "station_base.h"
+
+/**
+ * Run moving average decrease function on all items from a pool which are due
+ * this tick. This function expects to be run every tick. It calls a method
+ * "RunAverages()" on all items for which id % ORIG_DAY_TICKS == _tick_counter % ORIG_DAY_TICKS.
+ * So each item is called once a day.
+ */
+template <class Titem> void RunAverages()
+{
+	for (uint id = _tick_counter % DAY_TICKS; id < Titem::GetPoolSize(); id += DAY_TICKS) {
+		Titem *item = Titem::GetIfValid(id);
+		if (item != NULL) item->RunAverages();
+	}
+}
+
+template class MovingAverage<uint>;
+template void RunAverages<Station>();
diff --git a/src/moving_average.h b/src/moving_average.h
new file mode 100644
--- /dev/null
+++ b/src/moving_average.h
@@ -0,0 +1,78 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file moving_average.h Utility class for moving averages. */
+
+#ifndef MOVING_AVERAGE_H_
+#define MOVING_AVERAGE_H_
+
+#include "stdafx.h"
+#include "settings_type.h"
+#include "core/math_func.hpp"
+
+/**
+ * Class implementing moving average functionality. An instance of this class
+ * can be used to get a meaningful (Monthly()) value from a moving average and
+ * it can be used to do the decrease operation.
+ * @tparam Tvalue Type supporting operator*(uint), operator/(uint),
+ * operator*=(uint) and operator/=(uint) with the usual semantics.
+ */
+template<class Tvalue>
+class MovingAverage {
+protected:
+	uint length;
+
+public:
+	/**
+	 * Create a moving average.
+	 * @param length Length to be used.
+	 */
+	FORCEINLINE MovingAverage(uint length) : length(length)
+		{
+			assert(this->length > 0);
+		}
+
+	/**
+	 * Get the length of this moving average.
+	 * @return Length
+	 */
+	FORCEINLINE uint Length() const
+		{
+			return this->length;
+		}
+
+	/**
+	 * Get the current average for 30 "length units" from the given value.
+	 * Mind that no one forces you to decrease the average daily. If you
+	 * don't this is not a real "monthly" value. In any case it's not really
+	 * "monthly" as we don't account for months with different numbers of
+	 * days than 30. It doesn't matter, though. The point is to get an
+	 * average over a defined past timeframe.
+	 * @param value Raw moving average.
+	 * @return 30 "length unit" average.
+	 */
+	FORCEINLINE Tvalue Monthly(const Tvalue &value) const
+	{
+		return (value * 30) / (this->length);
+	}
+
+	/**
+	 * Decrease the given value using this moving average.
+	 * @param value Moving average value to be decreased.
+	 * @return Decreased value.
+	 */
+	FORCEINLINE Tvalue &Decrease(Tvalue &value) const
+	{
+		return value = (value * this->length) / (this->length + 1);
+	}
+};
+
+template<class Titem> void RunAverages();
+
+#endif /* MOVING_AVERAGE_H_ */
diff --git a/src/music_gui.cpp b/src/music_gui.cpp
--- a/src/music_gui.cpp
+++ b/src/music_gui.cpp
@@ -22,7 +22,6 @@
 #include "gui.h"
 #include "core/geometry_func.hpp"
 #include "string_func.h"
-#include "settings_type.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -64,8 +63,8 @@
 /** Indices of all ezy street songs */
 static byte _playlist_ezy_street[NUM_SONGS_CLASS + 1];
 
-assert_compile(lengthof(_settings_client.music.custom_1) == NUM_SONGS_PLAYLIST + 1);
-assert_compile(lengthof(_settings_client.music.custom_2) == NUM_SONGS_PLAYLIST + 1);
+assert_compile(lengthof(_msf.custom_1) == NUM_SONGS_PLAYLIST + 1);
+assert_compile(lengthof(_msf.custom_2) == NUM_SONGS_PLAYLIST + 1);
 
 /** The different playlists that can be played. */
 static byte * const _playlists[] = {
@@ -73,8 +72,8 @@
 	_playlist_old_style,
 	_playlist_new_style,
 	_playlist_ezy_street,
-	_settings_client.music.custom_1,
-	_settings_client.music.custom_2,
+	_msf.custom_1,
+	_msf.custom_2,
 };
 
 /**
@@ -197,17 +196,17 @@
 
 	memset(_cur_playlist, 0, sizeof(_cur_playlist));
 	do {
-		const char *filename = BaseMusic::GetUsedSet()->files[_playlists[_settings_client.music.playlist][i] - 1].filename;
+		const char *filename = BaseMusic::GetUsedSet()->files[_playlists[_msf.playlist][i] - 1].filename;
 		/* We are now checking for the existence of that file prior
 		 * to add it to the list of available songs */
 		if (!StrEmpty(filename) && FioCheckFileExists(filename, GM_DIR)) {
-			_cur_playlist[j] = _playlists[_settings_client.music.playlist][i];
+			_cur_playlist[j] = _playlists[_msf.playlist][i];
 			j++;
 		}
-	} while (_playlists[_settings_client.music.playlist][++i] != 0 && j < lengthof(_cur_playlist) - 1);
+	} while (_playlists[_msf.playlist][++i] != 0 && j < lengthof(_cur_playlist) - 1);
 
 	/* Do not shuffle when on the intro-start window, as the song to play has to be the original TTD Theme*/
-	if (_settings_client.music.shuffle && _game_mode != GM_MENU) {
+	if (_msf.shuffle && _game_mode != GM_MENU) {
 		i = 500;
 		do {
 			uint32 r = InteractiveRandom();
@@ -241,7 +240,7 @@
 		if (_cur_playlist[0] == 0) {
 			_song_is_active = false;
 			_music_wnd_cursong = 0;
-			_settings_client.music.playing = false;
+			_msf.playing = false;
 			return;
 		}
 	}
@@ -260,9 +259,9 @@
 
 void MusicLoop()
 {
-	if (!_settings_client.music.playing && _song_is_active) {
+	if (!_msf.playing && _song_is_active) {
 		StopMusic();
-	} else if (_settings_client.music.playing && !_song_is_active) {
+	} else if (_msf.playing && !_song_is_active) {
 		PlayPlaylistSong();
 	}
 
@@ -281,7 +280,7 @@
 
 static void SelectPlaylist(byte list)
 {
-	_settings_client.music.playlist = list;
+	_msf.playlist = list;
 	InvalidateWindowData(WC_MUSIC_TRACK_SELECTION, 0);
 	InvalidateWindowData(WC_MUSIC_WINDOW, 0);
 }
@@ -305,15 +304,15 @@
 		this->InitNested(desc, number);
 		this->LowerWidget(MTSW_LIST_LEFT);
 		this->LowerWidget(MTSW_LIST_RIGHT);
-		this->SetWidgetDisabledState(MTSW_CLEAR, _settings_client.music.playlist <= 3);
-		this->LowerWidget(MTSW_ALL + _settings_client.music.playlist);
+		this->SetWidgetDisabledState(MTSW_CLEAR, _msf.playlist <= 3);
+		this->LowerWidget(MTSW_ALL + _msf.playlist);
 	}
 
 	virtual void SetStringParameters(int widget) const
 	{
 		switch (widget) {
 			case MTSW_PLAYLIST:
-				SetDParam(0, STR_MUSIC_PLAYLIST_ALL + _settings_client.music.playlist);
+				SetDParam(0, STR_MUSIC_PLAYLIST_ALL + _msf.playlist);
 				break;
 		}
 	}
@@ -327,9 +326,9 @@
 	{
 		if (!gui_scope) return;
 		for (int i = 0; i < 6; i++) {
-			this->SetWidgetLoweredState(MTSW_ALL + i, i == _settings_client.music.playlist);
+			this->SetWidgetLoweredState(MTSW_ALL + i, i == _msf.playlist);
 		}
-		this->SetWidgetDisabledState(MTSW_CLEAR, _settings_client.music.playlist <= 3);
+		this->SetWidgetDisabledState(MTSW_CLEAR, _msf.playlist <= 3);
 		this->SetDirty();
 	}
 
@@ -395,7 +394,7 @@
 				GfxFillRect(r.left + 1, r.top + 1, r.right - 1, r.bottom - 1, PC_BLACK);
 
 				int y = r.top + WD_FRAMERECT_TOP;
-				for (const byte *p = _playlists[_settings_client.music.playlist]; *p != 0; p++) {
+				for (const byte *p = _playlists[_msf.playlist]; *p != 0; p++) {
 					uint i = *p - 1;
 					SetDParam(0, GetTrackNumber(i));
 					SetDParam(1, 2);
@@ -414,10 +413,10 @@
 			case MTSW_LIST_LEFT: { // add to playlist
 				int y = this->GetRowFromWidget(pt.y, widget, 0, FONT_HEIGHT_SMALL);
 
-				if (_settings_client.music.playlist < 4) return;
+				if (_msf.playlist < 4) return;
 				if (!IsInsideMM(y, 0, BaseMusic::GetUsedSet()->num_available)) return;
 
-				byte *p = _playlists[_settings_client.music.playlist];
+				byte *p = _playlists[_msf.playlist];
 				for (uint i = 0; i != NUM_SONGS_PLAYLIST - 1; i++) {
 					if (p[i] == 0) {
 						/* Find the actual song number */
@@ -439,10 +438,10 @@
 			case MTSW_LIST_RIGHT: { // remove from playlist
 				int y = this->GetRowFromWidget(pt.y, widget, 0, FONT_HEIGHT_SMALL);
 
-				if (_settings_client.music.playlist < 4) return;
+				if (_msf.playlist < 4) return;
 				if (!IsInsideMM(y, 0, NUM_SONGS_PLAYLIST)) return;
 
-				byte *p = _playlists[_settings_client.music.playlist];
+				byte *p = _playlists[_msf.playlist];
 				for (uint i = y; i != NUM_SONGS_PLAYLIST - 1; i++) {
 					p[i] = p[i + 1];
 				}
@@ -453,7 +452,7 @@
 			}
 
 			case MTSW_CLEAR: // clear
-				for (uint i = 0; _playlists[_settings_client.music.playlist][i] != 0; i++) _playlists[_settings_client.music.playlist][i] = 0;
+				for (uint i = 0; _playlists[_msf.playlist][i] != 0; i++) _playlists[_msf.playlist][i] = 0;
 				this->SetDirty();
 				StopMusic();
 				SelectSongToPlay();
@@ -546,8 +545,8 @@
 	MusicWindow(const WindowDesc *desc, WindowNumber number) : Window()
 	{
 		this->InitNested(desc, number);
-		this->LowerWidget(_settings_client.music.playlist + MW_ALL);
-		this->SetWidgetLoweredState(MW_SHUFFLE, _settings_client.music.shuffle);
+		this->LowerWidget(_msf.playlist + MW_ALL);
+		this->SetWidgetLoweredState(MW_SHUFFLE, _msf.shuffle);
 	}
 
 	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
@@ -620,7 +619,7 @@
 
 			case MW_MUSIC_VOL: case MW_EFFECT_VOL: {
 				DrawFrameRect(r.left, r.top + 2, r.right, r.bottom - 2, COLOUR_GREY, FR_LOWERED);
-				byte volume = (widget == MW_MUSIC_VOL) ? _settings_client.music.music_vol : _settings_client.music.effect_vol;
+				byte volume = (widget == MW_MUSIC_VOL) ? _msf.music_vol : _msf.effect_vol;
 				int x = (volume * (r.right - r.left) / 127);
 				if (_current_text_dir == TD_RTL) {
 					x = r.right - x;
@@ -642,7 +641,7 @@
 	{
 		if (!gui_scope) return;
 		for (int i = 0; i < 6; i++) {
-			this->SetWidgetLoweredState(MW_ALL + i, i == _settings_client.music.playlist);
+			this->SetWidgetLoweredState(MW_ALL + i, i == _msf.playlist);
 		}
 		this->SetDirty();
 	}
@@ -663,17 +662,17 @@
 				break;
 
 			case MW_STOP: // stop playing
-				_settings_client.music.playing = false;
+				_msf.playing = false;
 				break;
 
 			case MW_PLAY: // start playing
-				_settings_client.music.playing = true;
+				_msf.playing = true;
 				break;
 
 			case MW_MUSIC_VOL: case MW_EFFECT_VOL: { // volume sliders
 				int x = pt.x - this->GetWidget<NWidgetBase>(widget)->pos_x;
 
-				byte *vol = (widget == MW_MUSIC_VOL) ? &_settings_client.music.music_vol : &_settings_client.music.effect_vol;
+				byte *vol = (widget == MW_MUSIC_VOL) ? &_msf.music_vol : &_msf.effect_vol;
 
 				byte new_vol = x * 127 / this->GetWidget<NWidgetBase>(widget)->current_x;
 				if (_current_text_dir == TD_RTL) new_vol = 127 - new_vol;
@@ -688,8 +687,8 @@
 			}
 
 			case MW_SHUFFLE: // toggle shuffle
-				_settings_client.music.shuffle ^= 1;
-				this->SetWidgetLoweredState(MW_SHUFFLE, _settings_client.music.shuffle);
+				_msf.shuffle ^= 1;
+				this->SetWidgetLoweredState(MW_SHUFFLE, _msf.shuffle);
 				this->SetWidgetDirty(MW_SHUFFLE);
 				StopMusic();
 				SelectSongToPlay();
diff --git a/src/network/network_client.cpp b/src/network/network_client.cpp
--- a/src/network/network_client.cpp
+++ b/src/network/network_client.cpp
@@ -580,6 +580,8 @@
 		p->Recv_string(company_info->clients, sizeof(company_info->clients));
 
 		SetWindowDirty(WC_NETWORK_WINDOW, 0);
+		InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+		SetWindowClassesDirty(WC_WATCH_COMPANY);
 
 		return NETWORK_RECV_STATUS_OKAY;
 	}
@@ -620,6 +622,8 @@
 		strecpy(ci->client_name, name, lastof(ci->client_name));
 
 		SetWindowDirty(WC_CLIENT_LIST, 0);
+		InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+		SetWindowClassesDirty(WC_WATCH_COMPANY);
 
 		return NETWORK_RECV_STATUS_OKAY;
 	}
@@ -1026,6 +1030,8 @@
 	}
 
 	SetWindowDirty(WC_CLIENT_LIST, 0);
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+	SetWindowClassesDirty(WC_WATCH_COMPANY);
 
 	/* If we come here it means we could not locate the client.. strange :s */
 	return NETWORK_RECV_STATUS_OKAY;
@@ -1043,6 +1049,8 @@
 	}
 
 	SetWindowDirty(WC_CLIENT_LIST, 0);
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+	SetWindowClassesDirty(WC_WATCH_COMPANY);
 
 	return NETWORK_RECV_STATUS_OKAY;
 }
@@ -1112,6 +1120,8 @@
 	if (client_id == _network_own_client_id) {
 		SetLocalCompany(company_id);
 	}
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
+	SetWindowClassesDirty(WC_WATCH_COMPANY);
 
 	return NETWORK_RECV_STATUS_OKAY;
 }
diff --git a/src/network/network_gui.cpp b/src/network/network_gui.cpp
--- a/src/network/network_gui.cpp
+++ b/src/network/network_gui.cpp
@@ -30,6 +30,7 @@
 #include "../core/geometry_func.hpp"
 #include "../newgrf_text.h"
 #include "../genworld.h"
+#include "../newgrf.h"
 
 #include "table/strings.h"
 #include "../table/sprites.h"
@@ -1193,6 +1194,14 @@
 			}
 
 			case NSSW_GENERATE_GAME: // Start game
+				{
+					int numof_opened_grfs = CountSelectedGRFs (_grfconfig_newgame);
+					//DEBUG(grf, 0,  "numof_opened_grfs = %d", numof_opened_grfs);
+					if ( numof_opened_grfs >= MAX_FILE_SLOTS_IN_NETWORK ) {
+						ShowErrorMessage(STR_NEWGRF_ERROR_TOO_MANY_NEWGRFS_LOADED, INVALID_STRING_ID, WL_ERROR);
+						break; // break case NSSW_START
+					}
+				}
 				_is_network_server = true;
 				if (_ctrl_pressed) {
 					StartNewGameWithoutGUI(GENERATE_NEW_SEED);
diff --git a/src/network/network_server.cpp b/src/network/network_server.cpp
--- a/src/network/network_server.cpp
+++ b/src/network/network_server.cpp
@@ -1822,7 +1822,7 @@
 			} else {
 				cs->lag_test = 0;
 			}
-			if (cs->last_frame_server - cs->last_token_frame >= 5 * DAY_TICKS) {
+			if (cs->last_frame_server - cs->last_token_frame >= 5 * (uint)DAY_TICKS) {
 				/* This is a bad client! It didn't send the right token back. */
 				IConsolePrintF(CC_ERROR, "Client #%d is dropped because it fails to send valid acks", cs->client_id);
 				cs->CloseConnection(NETWORK_RECV_STATUS_SERVER_ERROR);
@@ -1837,7 +1837,7 @@
 			}
 		} else if (cs->status == NetworkClientSocket::STATUS_INACTIVE) {
 			uint lag = NetworkCalculateLag(cs);
-			if (lag > 4 * DAY_TICKS) {
+			if (lag > 4 * (uint)DAY_TICKS) {
 				IConsolePrintF(CC_ERROR,"Client #%d is dropped because it took longer than %d ticks to start the joining process", cs->client_id, 4 * DAY_TICKS);
 				cs->CloseConnection(NETWORK_RECV_STATUS_SERVER_ERROR);
 				continue;
diff --git a/src/newgrf.cpp b/src/newgrf.cpp
--- a/src/newgrf.cpp
+++ b/src/newgrf.cpp
@@ -2424,7 +2424,7 @@
 				} else if (buf->Remaining() < SNOW_LINE_MONTHS * SNOW_LINE_DAYS) {
 					grfmsg(1, "GlobalVarChangeInfo: Not enough entries set in the snowline table (" PRINTF_SIZE ")", buf->Remaining());
 				} else {
-					byte table[SNOW_LINE_MONTHS][SNOW_LINE_DAYS];
+					uint16 table[SNOW_LINE_MONTHS][SNOW_LINE_DAYS];
 
 					for (uint i = 0; i < SNOW_LINE_MONTHS; i++) {
 						for (uint j = 0; j < SNOW_LINE_DAYS; j++) {
@@ -8832,6 +8832,9 @@
 	/* Create dynamic list of industry legends for smallmap_gui.cpp */
 	BuildIndustriesLegend();
 
+	/* build the routemap legend, based on the available cargos */
+	BuildLinkStatsLegend();
+
 	/* Add all new airports to the airports array. */
 	FinaliseAirportsArray();
 	BindAirportSpecs();
@@ -8981,3 +8984,16 @@
 {
 	return HasBit(_misc_grf_features, bit);
 }
+
+/**
+ * Returns amount of user selected NewGRFs files.
+ */
+int CountSelectedGRFs(GRFConfig *grfconf)
+{	
+	int i = 0;
+	
+	/* Find last entry in the list */
+	for (const GRFConfig *list = grfconf; list != NULL; list = list->next , i++) {
+	}
+	return i;
+}
diff --git a/src/newgrf.h b/src/newgrf.h
--- a/src/newgrf.h
+++ b/src/newgrf.h
@@ -178,5 +178,6 @@
 
 StringID MapGRFStringID(uint32 grfid, StringID str);
 void ShowNewGRFError();
+int  CountSelectedGRFs (GRFConfig *grfconf);
 
 #endif /* NEWGRF_H */
diff --git a/src/newgrf_debug_gui.cpp b/src/newgrf_debug_gui.cpp
--- a/src/newgrf_debug_gui.cpp
+++ b/src/newgrf_debug_gui.cpp
@@ -45,7 +45,7 @@
  */
 static inline uint GetFeatureIndex(uint window_number)
 {
-	return GB(window_number, 0, 24);
+	return GB(window_number, 0, 27);
 }
 
 /**
@@ -57,8 +57,8 @@
  */
 static inline uint GetInspectWindowNumber(GrfSpecFeature feature, uint index)
 {
-	assert((index >> 24) == 0);
-	return (feature << 24) | index;
+	assert((index >> 27) == 0);
+	return (feature << 27) | index;
 }
 
 /**
@@ -249,7 +249,7 @@
  */
 static inline GrfSpecFeature GetFeatureNum(uint window_number)
 {
-	return (GrfSpecFeature)GB(window_number, 24, 8);
+	return (GrfSpecFeature)GB(window_number, 27, 8);
 }
 
 /**
diff --git a/src/newgrf_engine.cpp b/src/newgrf_engine.cpp
--- a/src/newgrf_engine.cpp
+++ b/src/newgrf_engine.cpp
@@ -552,7 +552,7 @@
 
 			{
 				const Vehicle *w = v->Next();
-				uint16 altitude = v->z_pos - w->z_pos; // Aircraft height - shadow height
+				uint32 altitude = v->z_pos - w->z_pos; // Aircraft height - shadow height
 				byte airporttype = ATP_TTDP_LARGE;
 
 				const Station *st = GetTargetAirportIfValid(Aircraft::From(v));
diff --git a/src/newgrf_object.h b/src/newgrf_object.h
--- a/src/newgrf_object.h
+++ b/src/newgrf_object.h
@@ -66,7 +66,7 @@
 	ObjectFlags flags;            ///< Flags/settings related to the object.
 	AnimationInfo animation;      ///< Information about the animation.
 	uint16 callback_mask;         ///< Bitmask of requested/allowed callbacks.
-	uint8 height;                 ///< The height of this structure, in heightlevels; max MAX_TILE_HEIGHT.
+	uint8 height;                 ///< The height of this structure, in heightlevels; max MAX_TILE_HEIGHT_OLD. Note: Do not increase unless the pillar-glitches are fixed with high bridges.
 	uint8 views;                  ///< The number of views.
 	bool enabled;                 ///< Is this spec enabled?
 
diff --git a/src/newgrf_station.h b/src/newgrf_station.h
--- a/src/newgrf_station.h
+++ b/src/newgrf_station.h
@@ -25,7 +25,7 @@
 	STAT_CLASS_BEGIN = 0,    ///< the lowest valid value
 	STAT_CLASS_DFLT = 0,     ///< Default station class.
 	STAT_CLASS_WAYP,         ///< Waypoint class.
-	STAT_CLASS_MAX = 32,     ///< Maximum number of classes.
+	STAT_CLASS_MAX = 96,     ///< Maximum number of classes.
 };
 typedef SimpleTinyEnumT<StationClassID, byte> StationClassIDByte;
 template <> struct EnumPropsT<StationClassID> : MakeEnumPropsT<StationClassID, byte, STAT_CLASS_BEGIN, STAT_CLASS_MAX, STAT_CLASS_MAX, 8> {};
diff --git a/src/openttd.cpp b/src/openttd.cpp
--- a/src/openttd.cpp
+++ b/src/openttd.cpp
@@ -25,6 +25,7 @@
 #include "saveload/saveload.h"
 #include "company_func.h"
 #include "command_func.h"
+#include "command_queue.h"
 #include "news_func.h"
 #include "fios.h"
 #include "aircraft.h"
@@ -49,6 +50,7 @@
 #include "animated_tile_func.h"
 #include "roadstop_base.h"
 #include "elrail_func.h"
+#include "copy_paste.h"
 #include "rev.h"
 #include "highscore.h"
 #include "thread/thread.h"
@@ -61,11 +63,15 @@
 #include "hotkeys.h"
 #include "newgrf.h"
 #include "misc/getoptdata.h"
+#include "programmable_signals.h"
 
+#include "newgrf.h"
 
 #include "town.h"
 #include "industry.h"
 
+#include "linkgraph/linkgraph.h"
+
 #include <stdarg.h>
 
 #include "table/strings.h"
@@ -292,6 +298,19 @@
 	/* Uninitialize variables that are allocated dynamically */
 	GamelogReset();
 
+// TODO: ¿ Move and clean like the other pools in r21113 ?
+
+	/* Reinitialize the link graphs to forcibly stop the threads.
+	 * If a link graph thread is running while the link graph handlers are
+	 * deleted we get a crash.
+	 */
+	InitializeLinkGraphs();
+
+	FreeSignalPrograms();
+	FreeSignalDependencies();
+ 	FreeSignalSpeeds();
+// END TODO
+
 #ifdef ENABLE_NETWORK
 	free(_config_file);
 #endif
@@ -760,7 +779,7 @@
 	_screen.zoom = ZOOM_LVL_NORMAL;
 
 	/* restore saved music volume */
-	_music_driver->SetVolume(_settings_client.music.music_vol);
+	_music_driver->SetVolume(_msf.music_vol);
 
 	NetworkStartUp(); // initialize network-core
 
@@ -865,6 +884,24 @@
 	MarkWholeScreenDirty();
 }
 
+/*
+ * Too large size may be stored in settings (especially if switching between between OpenTTD
+ * versions with different map size limits), we have to check if it is valid before generating world.
+ * Simple separate checking of X and Y map sizes is not enough, as their sum is what counts for the limit.
+ * Check the size and decrease the larger of the sizes till the size is in limit.
+ */
+static void FixConfigMapSize()
+{
+	while (_settings_game.game_creation.map_x + _settings_game.game_creation.map_y > MAX_MAP_TILES_BITS) {
+		/* Repeat reducing larger of X/Y dimensions until the map size is within allowable limits */
+		if (_settings_game.game_creation.map_x > _settings_game.game_creation.map_y) {
+			_settings_game.game_creation.map_x--;
+		} else {
+			_settings_game.game_creation.map_y--;
+		}
+	}
+}
+
 static void MakeNewGame(bool from_heightmap, bool reset_settings)
 {
 	_game_mode = GM_NORMAL;
@@ -872,6 +909,7 @@
 	ResetGRFConfig(true);
 
 	GenerateWorldSetCallback(&MakeNewGameDone);
+	FixConfigMapSize();
 	GenerateWorld(from_heightmap ? GWM_HEIGHTMAP : GWM_NEWGAME, 1 << _settings_game.game_creation.map_x, 1 << _settings_game.game_creation.map_y, reset_settings);
 }
 
@@ -887,6 +925,7 @@
 	ResetGRFConfig(true);
 
 	GenerateWorldSetCallback(&MakeNewEditorWorldDone);
+	FixConfigMapSize();
 	GenerateWorld(GWM_EMPTY, 1 << _settings_game.game_creation.map_x, 1 << _settings_game.game_creation.map_y);
 }
 
@@ -944,9 +983,13 @@
 
 void SwitchToMode(SwitchMode new_mode)
 {
+	//If we are not saving, the command_queue will be reset
+	if ((new_mode != SM_SAVE_GAME) && (new_mode != SM_SAVE_TEMPLATE) && (new_mode != SM_LOAD_TEMPLATE))
+		_copy_paste_command_queue.ClearCopyPasteCommandQueue();
+
 #ifdef ENABLE_NETWORK
 	/* If we are saving something, the network stays in his current state */
-	if (new_mode != SM_SAVE_GAME) {
+	if (new_mode != SM_SAVE_GAME && new_mode != SM_SAVE_TEMPLATE && new_mode != SM_LOAD_TEMPLATE) {
 		/* If the network is active, make it not-active */
 		if (_networking) {
 			if (_network_server && (new_mode == SM_LOAD_GAME || new_mode == SM_NEWGAME || new_mode == SM_RESTARTGAME)) {
@@ -1031,6 +1074,7 @@
 		case SM_LOAD_HEIGHTMAP: // Load heightmap from scenario editor
 			SetLocalCompany(OWNER_NONE);
 
+			FixConfigMapSize();
 			GenerateWorld(GWM_HEIGHTMAP, 1 << _settings_game.game_creation.map_x, 1 << _settings_game.game_creation.map_y);
 			MarkWholeScreenDirty();
 			break;
@@ -1073,11 +1117,30 @@
 
 		case SM_GENRANDLAND: // Generate random land within scenario editor
 			SetLocalCompany(OWNER_NONE);
+			FixConfigMapSize();
 			GenerateWorld(GWM_RANDOM, 1 << _settings_game.game_creation.map_x, 1 << _settings_game.game_creation.map_y);
 			/* XXX: set date */
 			MarkWholeScreenDirty();
 			break;
 
+		case SM_SAVE_TEMPLATE: /* Save Template */
+			if (_copy_paste.SaveLoadTemplate(_file_to_saveload.name, SL_SAVE) != SL_OK) {
+				SetDParamStr(0, _copy_paste.GetErrorString());
+				ShowErrorMessage(INVALID_STRING_ID, STR_JUST_RAW_STRING, WL_ERROR);
+			} else {
+				DeleteWindowById(WC_SAVELOAD, 0);
+			}
+			break;
+
+		case SM_LOAD_TEMPLATE: /* Load Template */
+			if (_copy_paste.SaveLoadTemplate(_file_to_saveload.name, SL_LOAD) != SL_OK) {
+				SetDParamStr(0, _copy_paste.GetErrorString());
+				ShowErrorMessage(INVALID_STRING_ID, STR_JUST_RAW_STRING, WL_ERROR);
+			} else {
+				DeleteWindowById(WC_SAVELOAD, 0);
+			}
+			break;
+
 		default: NOT_REACHED();
 	}
 
@@ -1240,6 +1303,8 @@
 
 		CheckCaches();
 
+		CallCopyPasteCommandQueueTick();
+
 		/* All these actions has to be done from OWNER_NONE
 		 *  for multiplayer compatibility */
 		Backup<CompanyByte> cur_company(_current_company, OWNER_NONE, FILE_LINE);
@@ -1256,6 +1321,7 @@
 
 		CallWindowTickEvent();
 		NewsLoop();
+
 		cur_company.Restore();
 	}
 
diff --git a/src/openttd.h b/src/openttd.h
--- a/src/openttd.h
+++ b/src/openttd.h
@@ -35,6 +35,8 @@
 	SM_LOAD_SCENARIO,   ///< Load scenario from scenario editor.
 	SM_START_HEIGHTMAP, ///< Load a heightmap and start a new game from it.
 	SM_LOAD_HEIGHTMAP,  ///< Load heightmap from scenario editor.
+	SM_SAVE_TEMPLATE,
+	SM_LOAD_TEMPLATE,
 };
 
 /** Display Options */
diff --git a/src/order_base.h b/src/order_base.h
--- a/src/order_base.h
+++ b/src/order_base.h
@@ -195,6 +195,16 @@
 private:
 	friend void AfterLoadVehicles(bool part_of_load); ///< For instantiating the shared vehicle chain
 	friend const struct SaveLoad *GetOrderListDescription(); ///< Saving and loading of order lists.
+	
+	/**
+	 * Get the order after the given one or the first one, if the given one is the
+	 * last one.
+	 * @param curr Order to find the next one for.
+	 * @return Next order.
+	 */
+	inline const Order *GetNext(const Order *curr) const { return (curr->next == NULL) ? this->GetFirstOrder() : curr->next; }
+
+	StationID GetNextStoppingStation(const Order *next, StationID curr_station, uint hops) const;
 
 	Order *first;                     ///< First order of the order list.
 	VehicleOrderID num_orders;        ///< NOSAVE: How many orders there are in the list.
@@ -236,6 +246,8 @@
 	 */
 	inline Order *GetLastOrder() const { return this->GetOrderAt(this->num_orders - 1); }
 
+	StationID GetNextStoppingStation(VehicleOrderID curr_order, StationID curr_station) const;
+
 	/**
 	 * Get number of orders in the order list.
 	 * @return number of orders in the chain.
